/****************************************************************************
    Qt-LCoV Library Editor for Qt-BSch3V
    Copyright (C) 2002-2005 H.Okada

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*****************************************************************************/

#ifndef DRAWCOMPONENTBASE_H
#define DRAWCOMPONENTBASE_H

//void g_drawComponentBody(QPainter* p,
//						 const SCompIndex* compInfo,
//						 const SPoint& pos,
//						 const SSize& size,
//						 int dir,
//						 unsigned  nMode,
//						 int nScale);
void g_drawComponentPin(QPainter* p,const SPoint& pt,int nLtrb,int nType,unsigned  nMode,int nScale);
//SRect g_drawComponentPinArea(const SPoint& pt,int nLtrb);
SRect g_drawComponentPinNameArea(const SPoint& pt,int nLtrb,const char* name);
SRect g_drawComponentPinNumArea(const SPoint& pt,int nLtrb,const char* name,int pintype);
void g_drawComponentPinNum(QPainter* p,const SRect& rc,int nLtrb,unsigned  nMode,QColor colText,const char* name,int nScale,int nScaleMul);
void g_drawComponentPinName(QPainter* p,const SRect& rc,int nLtrb,unsigned  nMode,QColor colText,const char* name,int nScale,int nScaleMul);



SSize g_drawComponentNumName(QPainter* p,const SRect& rc,unsigned  nMode,bool bVert,QColor colText,const char* name,int nScale,int nScaleMul);

//ʤ
void g_drawComponentBase(QPainter* p,
						 const SCompIndex* compInfo,
						 const SPoint& pos,
						 const SSize& size,
						 int dir,
						 int nBlock,
						 unsigned  nMode,
						 SRect* prcClip,
						 int nScale,
						 int nScaleMul,						 
						 bool dispAllNum=false);


void convDirXY(int&rx,int&ry,int dir,int cx,int cy);

void g_DrawPtnLine(
		QPainter* p,					//
		SPtnObjLine* pPtnObj,			//襪֥
		const QColor& col,			//迧
		int  dir,
		int  cx,
		int  cy,
		int  x0,
		int  y0,
		int  nScale,				
		int  nScaleMul);

void g_DrawPtnCircle(
		QPainter* p,				//
		SPtnObjCircle* pPtnObj,	//襪֥
		const QColor& col,			//迧
		int	 dir,
		int	 cx,
		int  cy,
		int	 x0,
		int  y0,
		int  nScale,				//
		int  nScaleMul);

void g_DrawPtnPolygon(
		QPainter* p,				//
		SPtnObjPolygon* pPtnObj,	//襪֥
		const QColor& col,			//迧
		int	 dir,
		int	 cx,
		int  cy,
		int	 x0,
		int  y0,
		int  nScale,
		int  nScaleMul);

void g_DrawPtnArc(
		QPainter* p,				//
		SPtnObjArc* pPtnObj,	//襪֥
		const QColor& col,			//迧
		int	 dir,
		int	 cx,
		int  cy,
		int	 x0,
		int  y0,
		int  nScale,
		int  nScaleMul);

void g_drawComponentPin(
		QPainter* p,
		const SPoint& pt,
		int nLtrb,
		int nType,
		unsigned  nMode,
		int nScale,
		int nScaleMul);



#endif
